import { OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Extent } from 'ol/extent';
import RenderEvent from 'ol/render/Event';
import { MapComponent } from '../map.component';
import { LayerGroupComponent } from './layergroup.component';
import Map from 'ol/Map';
import * as i0 from "@angular/core";
export declare abstract class LayerComponent implements OnInit, OnChanges, OnDestroy {
    protected host: MapComponent | LayerGroupComponent;
    className: string;
    opacity: number;
    visible: boolean;
    extent: Extent;
    zIndex: number;
    minResolution: number;
    maxResolution: number;
    minZoom: number;
    maxZoom: number;
    map: Map;
    properties: {
        [x: string]: unknown;
    };
    prerender: (evt: RenderEvent) => void;
    postrender: (evt: RenderEvent) => void;
    instance: any;
    componentType: string;
    constructor(host: MapComponent | LayerGroupComponent);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LayerComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<LayerComponent, never, never, { "className": { "alias": "className"; "required": false; }; "opacity": { "alias": "opacity"; "required": false; }; "visible": { "alias": "visible"; "required": false; }; "extent": { "alias": "extent"; "required": false; }; "zIndex": { "alias": "zIndex"; "required": false; }; "minResolution": { "alias": "minResolution"; "required": false; }; "maxResolution": { "alias": "maxResolution"; "required": false; }; "minZoom": { "alias": "minZoom"; "required": false; }; "maxZoom": { "alias": "maxZoom"; "required": false; }; "map": { "alias": "map"; "required": false; }; "properties": { "alias": "properties"; "required": false; }; "prerender": { "alias": "prerender"; "required": false; }; "postrender": { "alias": "postrender"; "required": false; }; }, {}, never, never, false, never>;
}
